#include  "header.h"

//Dialogue procedure for IDD_DIALOG1
BOOL CALLBACK dlgproc( HWND hDlg, UINT msg, WPARAM wp, LPARAM lp )
{	
	//The followings are used in IDC_BUTTON_FOLDER_OPEN.
	BROWSEINFO bi;
	ITEMIDLIST *idl;						//???""In x64 applications, the modifier "__unaligned" is not necessary.""???
	LPMALLOC g_pMalloc;
	SHGetMalloc(&g_pMalloc);
	char szTmp[MAX_PATH]={ "C:\\*.ser" };	//Path name for a folder; MAX_PATH is the upper limit of the number of characters, 260.

	bi.hwndOwner = NULL;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = szTmp;
	bi.lpszTitle = TEXT("Select a folder");
	bi.ulFlags = BIF_RETURNONLYFSDIRS;
	bi.lpfn = NULL;
	bi.lParam = 0;
	bi.iImage = 0;

	//The followings are used in a ListViewBox in the DialogBox.
	static LVHITTESTINFO lvinfo;	//ListView informations are stored in "lvinfo".
	UINT uiState;					//State of an item in the ListView (IDC_LIST2).
	static int	n_item;				//An Item Number in the ListView (IDC_LIST2); Corresponding to a SER file.
	static int  i_scan;				//An Item Number in the ListView (IDC_LIST2) to be scaned.

	//The followings are used in Spin Controls.
	LPNMUPDOWN lpnmud;
	int c_frame_step;				//Step of the frame number in a SER file.

	//The followings are for the others.
	static SYSTEMTIME st_start, st_end;	//The start and the end times of the whole scan procedures.
	static errno_t	error;			//Results of the "fopen_s" function.
	static RECT		dlg_rect;		//The position of the DialogBox.
	static char		*path_name1;	//The path name for a SER file to be scaned.
	static char		*file_name;		//The name of a SER file without an extention to be scaned.
	static char		*str_header;	//The header of a SER file.

	static int total_packet;		//The number of packets in a SER file.
	static int r_frames;			//The number of residual frames when frames in a SER file are divided into packets.
	static int threshold0;			//The initial threshold value for detections.

	static HWND hCheck_blue_red;	//The handle for a CheckButton which determines whether dark pixels and bright pixels are displayed in colour or not.

	static HWND hRadio_disp100, hRadio_disp50, hRadio_disp33, hRadio_disp25;	//Handles for selecting image display size.

	char ch[100]={};				//Used in IDC_BUTTON_FILE_TO_FILE.
	static int i, j, k;
	BOOL check;

	switch(msg){
	case WM_INITDIALOG:
        hList2 = GetDlgItem( hDlg, IDC_LIST2 );	//"IDC_LIST2" is the ListViewBox in the right side in the DialogBox.
		LIST2_prep();							//Preparation of "LIST2" in the dialog box.

        list_item.mask = LVIF_TEXT;				//Make ".pszText" an active member of "list_item", a LVITEM structure.

		SetDlgItemInt( hDlg, IDC_EDIT_BIT_SHIFT,   0, TRUE  );	//Bit shift in reading 16-bit pixel values of a SER image file.

		SetDlgItemInt( hDlg, IDC_EDIT_THRESHOLD0, 60, FALSE );	//(The initial threshold value for detections) times 10.
		SetDlgItemInt( hDlg, IDC_EDIT_dTHRESHOLD,  3, FALSE );	//The step of the threshold value.
		SetDlgItemInt( hDlg, IDC_EDIT_UE,     25, FALSE );		//For a detection, the upper adjacent pixel needs to be brighter than 25 % of the pixel brightness that exceeds a threshold.
		SetDlgItemInt( hDlg, IDC_EDIT_SHITA,  25, FALSE );		//Lower adjacent.
		SetDlgItemInt( hDlg, IDC_EDIT_MIGI,   25, FALSE );		//Right side adjacent.
		SetDlgItemInt( hDlg, IDC_EDIT_HIDARI, 25, FALSE );		//Left side adjacdent.

		hCheck_mask_bright = GetDlgItem( hDlg, IDC_CHECK_MASK_BRIGHT );	//If the CheckButton, IDC_CHECK_MASK_BRIGHT, in the DialogBox is checked, bright pixcels and their adjacent ones are masked for detections.
		Button_SetCheck( hCheck_mask_bright, BST_UNCHECKED );			//Uncheck as an initial condition.
		hCheck_mask_dark   = GetDlgItem( hDlg, IDC_CHECK_MASK_DARK   );	//For dark pixel masks;
		Button_SetCheck( hCheck_mask_dark  , BST_UNCHECKED );
		hCheck_mask_star = GetDlgItem( hDlg, IDC_CHECK_MASK_STAR );		//For star masks;
		Button_SetCheck( hCheck_mask_star, BST_UNCHECKED );

		hCheck_blue_red = GetDlgItem( hDlg, IDC_CHECK_BLUE_RED );		//If IDC_CHECK_MASK_BRIGHT is checked, dark and bright pixels are displayed in color.
		Button_SetCheck( hCheck_blue_red, BST_UNCHECKED );

		SetDlgItemInt( hDlg, IDC_EDIT_MASK_AREA1, 10, FALSE );			//The size of the mask area, (the side length of a square - 1)/2, for bright pixels.
		SetDlgItemInt( hDlg, IDC_EDIT_MASK_AREA2, 10, FALSE );			//For dark pixels:
		SetDlgItemInt( hDlg, IDC_EDIT_MASK_AREA3,    10, FALSE );		//For stars:
		SetDlgItemInt( hDlg, IDC_EDIT_STAR_THRESHOLD,30, FALSE );		//A threshold for stellar image detections multiplied by 10.
		SetDlgItemInt( hDlg, IDC_EDIT_STAR_SEEING,   10, FALSE );		//(the side length of a square - 1)/2 for searching stars in a time-averaged image.  An average along the 4 sides of the square is used as a background.

		SetDlgItemInt( hDlg, IDC_EDIT_TL_X1, 0, FALSE );			//x-coordinate of the upper left corner of the 1st manual mask region
		SetDlgItemInt( hDlg, IDC_EDIT_TL_Y1, 0, FALSE );			//y-coordinate
		SetDlgItemInt( hDlg, IDC_EDIT_BR_X1, 0, FALSE );			//x-coordinate of the lower right corner
		SetDlgItemInt( hDlg, IDC_EDIT_BR_Y1, 0, FALSE );			//y-coordinate
		SetDlgItemInt( hDlg, IDC_EDIT_TL_X2, 0, FALSE );			//2nd mask area
		SetDlgItemInt( hDlg, IDC_EDIT_TL_Y2, 0, FALSE );
		SetDlgItemInt( hDlg, IDC_EDIT_BR_X2, 0, FALSE );
		SetDlgItemInt( hDlg, IDC_EDIT_BR_Y2, 0, FALSE );
		SetDlgItemInt( hDlg, IDC_EDIT_TL_X3, 0, FALSE );			//3rd mask area
		SetDlgItemInt( hDlg, IDC_EDIT_TL_Y3, 0, FALSE );
		SetDlgItemInt( hDlg, IDC_EDIT_BR_X3, 0, FALSE );
		SetDlgItemInt( hDlg, IDC_EDIT_BR_Y3, 0, FALSE );
		SetDlgItemInt( hDlg, IDC_EDIT_TL_X4, 0, FALSE );			//4th mask area
		SetDlgItemInt( hDlg, IDC_EDIT_TL_Y4, 0, FALSE );
		SetDlgItemInt( hDlg, IDC_EDIT_BR_X4, 0, FALSE );
		SetDlgItemInt( hDlg, IDC_EDIT_BR_Y4, 0, FALSE );

		hRadio_mask1  = GetDlgItem( hDlg, IDC_RADIO_1 );	//Get a handle for the setting of the mask region1.
		hRadio_mask2  = GetDlgItem( hDlg, IDC_RADIO_2 );
		hRadio_mask3  = GetDlgItem( hDlg, IDC_RADIO_3 );
		hRadio_mask4  = GetDlgItem( hDlg, IDC_RADIO_4 );
		Button_SetCheck( hRadio_mask1, BST_CHECKED );		//Select the setting of the mask region1.

		hCheck_disp_mask = GetDlgItem( hDlg, IDC_CHECK_DISP_MASK );	//Get a handle of the CHECK BOX that enable/disable showing the manual-mask-regions.
		Button_SetCheck( hCheck_disp_mask, BST_UNCHECKED );			//Default is UNCHECKED.

		SetDlgItemInt( hDlg, IDC_EDIT_SCATTER_i,  20, FALSE );	//The upper limit of the scatter of the y-coordinates of the detected points.
		SetDlgItemInt( hDlg, IDC_EDIT_SCATTER_j, 100, FALSE );

		hRadio_disp100  = GetDlgItem( hDlg, IDC_RADIO_100 );	//Get a handle for the 100% display size.
		hRadio_disp50   = GetDlgItem( hDlg, IDC_RADIO_50  );	//Get a handle for the  50% display size.
		hRadio_disp33   = GetDlgItem( hDlg, IDC_RADIO_33  );	//Get a handle for the  30% display size.
		hRadio_disp25   = GetDlgItem( hDlg, IDC_RADIO_25  );	//Get a handle for the  25% display size.
		Button_SetCheck( hRadio_disp100, BST_CHECKED );			//Select the 100% display size as a default.

		DlgDirList( hDlg, szTmp, IDC_LIST1, IDC_EDIT_PATH, DDL_DIRECTORY | DDL_DRIVES );

		list_file = 0;	//"list_file" is the number of SER files in "LIST2".
		n_frames  = 0;	//"n_frames" is the number of frames with detections in a SER file.

		return TRUE;

	case WM_NOTIFY:

		//When you double-click on the right ListBox, LIST2, in the DialogBox (See: http://gurigumi.s349.xrea.com/programming/visualcpp/sdk_dialog_listview3.html in Japanese).
		if( (((LPNMHDR)lp)->idFrom == IDC_LIST2) && (((LPNMLISTVIEW)lp)->hdr.code == NM_DBLCLK) ) {	//"lp" is one of the 4 arguments of this CALLBACK function "dlgproc".
			if( GetCursorPos((LPPOINT)&lvinfo.pt) ) {									//"lvinfo.pt" contains the coordinates in a screen.
				if( ScreenToClient(((LPNMLISTVIEW)lp)->hdr.hwndFrom, &lvinfo.pt) ) {	//"lvinfo.pt" contains the coordinates in the ListBox.
					list_item.iSubItem = get_iSubItem( lvinfo.pt.x );					//Calculate a subitem number in "LIST2" from a double-click position by means of "get_iSubItem", a handmade function.
					if( ListView_HitTest(((LPNMLISTVIEW)lp)->hdr.hwndFrom, &lvinfo) >= 0 ) {	//If getting an item in the ListBox suceeds;
						if( (lvinfo.flags & LVHT_ONITEM) != 0 ) {								//If the double-click occurs on an item;
							list_item.iItem = lvinfo.iItem;										//Get an item number that corresponds to a SER file.
							list_item.pszText = buf_for_dlg2;									//"buf_for_dlg2" gets the text information in "list_item.pszText".
							list_item.cchTextMax = 256;											//The maximum text length.
							ListView_GetItem( hList2, &list_item );								//Get a text information.

							if( list_item.iSubItem == 1 ) {										//If you double-click on the column for file names (subitem#1);

								//Determining the reduction ratio of the display window.
								if( Button_GetCheck( hRadio_disp100 ) == BST_CHECKED ) disp_size = 1;				//The size of the image window is 100%.
									else if( Button_GetCheck( hRadio_disp50  ) == BST_CHECKED ) disp_size = 2;		//The size of the image window is  50%.
										else if( Button_GetCheck( hRadio_disp33  ) == BST_CHECKED ) disp_size = 3;	//The size of the image window is  33%.
											else disp_size = 4;														//The size of the image window is  25%.

								check = show_file( list_item.iItem, Button_GetCheck( hCheck_blue_red ) );	//Display an image in the SER file.
								if( check == TRUE ) LIST2_set_checkmark( list_item.iItem );					//"LIST2_set_checkmark" shows "1" in the left end column of "list_item.iItem".
							}

							if( list_item.iSubItem >= 3  ) {									//If you double-click on the column for subitem# equal to or larger than 3.
								DialogBox( hInst, "IDD_DIALOG2", hDlg, (DLGPROC)dlgproc2);					//Create a small DialogBox to change a parameter in the ListBox, and wait the end of the procedure in the small DialogBox.
								if( !check_start_end_packet( list_item.iItem, list_item.iSubItem ) ) break;	//Check the interrelationships among subitem#s 2, 3, 4, and 6, that are related to frame numbers.
								list_item.pszText = buf_for_dlg2;											//The revised value is in "buf_for_dlg2".  Copy it to "list_item.pszText".
								ListView_SetItem( hList2, &list_item );										//Revise the ListBox.
							}
						}
					}
				}			
			}
		}
		
		//Increase or decrease of the frame number, c_frame, by SPIN CONTROL.
		if ( wp == (WPARAM)IDC_SPIN_FRAME0 || wp == (WPARAM)IDC_SPIN_FRAME1 || wp == (WPARAM)IDC_SPIN_FRAME2 || wp == (WPARAM)IDC_SPIN_FRAME3 ) {
			if ( wp == (WPARAM)IDC_SPIN_FRAME0 ) c_frame_step = 1;
			if ( wp == (WPARAM)IDC_SPIN_FRAME1 ) c_frame_step = 50;
			if ( wp == (WPARAM)IDC_SPIN_FRAME2 ) c_frame_step = 500;
			if ( wp == (WPARAM)IDC_SPIN_FRAME3 ) c_frame_step = 5000;
			n_item = LIST2_get_checkmarked_item();		//Get the item number (corresponding to a SER file) in "LIST2", whose left end column shows "1".
			if( n_item < 0 ) break;

			lpnmud = (LPNMUPDOWN)lp;
			if( lpnmud->hdr.code == UDN_DELTAPOS ) {
				c_frame = GetDlgItemInt( hDlg, IDC_EDIT_FRAME, &check, FALSE );
       
				if( (lpnmud->iDelta) < 0 ) c_frame += c_frame_step;
				if( (lpnmud->iDelta) > 0 ) c_frame -= c_frame_step;

				//Note: In the case "c_frame" is negative or too large, IDC_BUTTON_FRAME calls "c_frame_check" function and the function corrects it.
				SetDlgItemInt( hDlg, IDC_EDIT_FRAME, c_frame, FALSE );
				SendMessage( hDlg, WM_COMMAND, MAKEWPARAM(IDC_BUTTON_FRAME, 0), 0 );
			}
		}

		//Increase or decrease of "bit_shift" by SPIN CONTROL.
		if ( wp == (WPARAM)IDC_SPIN_BIT_SHIFT ) {
			lpnmud = (LPNMUPDOWN)lp;
			if( lpnmud->hdr.code == UDN_DELTAPOS ) {
				bit_shift = GetDlgItemInt( hDlg, IDC_EDIT_BIT_SHIFT, &check, FALSE );
       
				if( (lpnmud->iDelta) < 0 ) bit_shift++;
				if( (lpnmud->iDelta) > 0 ) bit_shift--;
				if( bit_shift < 0 ) bit_shift = 0;
				if( bit_shift > 8 ) bit_shift = 8;

				SetDlgItemInt( hDlg, IDC_EDIT_BIT_SHIFT, bit_shift, FALSE );
				SendMessage( hDlg, WM_COMMAND, MAKEWPARAM(IDC_BUTTON_FRAME, 0), 0 );
			}
		}

		break;

	case WM_COMMAND:
		switch(LOWORD(wp)){
			case IDC_BUTTON_FOLDER_OPEN:	//Open a folder that contains SER files.
				idl = SHBrowseForFolder( &bi );	//"bi" is a BROWSEINFO structure, and the location of the selected folder is returned to "idl".
				if( idl != NULL ) {				//If the user chooses the Cancel button in the dialog box, the return value is NULL.
					if( SHGetPathFromIDList( idl, szTmp ) != FALSE ) {	//Write the location of the folder in "szTmp".
						DlgDirList( hDlg, szTmp, IDC_LIST1, IDC_EDIT_PATH, DDL_DIRECTORY | DDL_DRIVES );	//Show files in the location in the left ListBox (IDC_LIST1).  The path name is shown in the EditControl (IDC_EDIT_PATH).
					}
					g_pMalloc->Free(idl);
				}
				break;

			case IDC_LIST1:		//Select a SER file in the left ListBox (See http://www.eonet.ne.jp/~maeda/winc/dirlist.htm in Japanese).
				if( HIWORD(wp) == LBN_DBLCLK ) {	//If the user double-click a file of a folder in the left ListBox.
					if( DlgDirSelectEx( hDlg, szTmp, sizeof(szTmp), IDC_LIST1 ) ) {	//If the user double-click a folder, the path name of the folder is written in "szTmp".
						DlgDirList( hDlg, szTmp, IDC_LIST1, IDC_EDIT_PATH, DDL_DIRECTORY | DDL_DRIVES );	//Show files in the location in the left ListBox (IDC_LIST1).  The path name is shown in the EditControl (IDC_EDIT_PATH).
					}
					else {	//If the user double-click a file, go to IDC_BUTTON_ADD below.
						SendMessage( hDlg, WM_COMMAND, MAKEWPARAM(IDC_BUTTON_ADD, 0), 0 );
					}
				}
				break;

			case IDC_BUTTON_ADD:	//Show the selected SER file in the right ListBox (LIST2), and disply its first frame in the window.
				if( list_file > 0 ) LIST2_deselect();	//If LIST2 shows at least one SER file;
				DlgDirSelectEx( hDlg, list_fname, sizeof(list_fname ), IDC_LIST1 );								//The name of the file selected in LIST1 is copied in "list_fname".
				GetDlgItemText( hDlg, IDC_EDIT_PATH, file_path[list_file], (int)sizeof(file_path[list_file]) );	//The path name shown in IDC_EDIT_PATH is copied in "file_path[list_file]". Because "file_path[0]" is for the first SER file in LIST2, "file_path[list_file]" is for the new file.
				strcat_s( file_path[list_file], sizeof(file_path[list_file]), "\\" );							//Add "\" to the path name.
				strcat_s( file_path[list_file], sizeof(file_path[list_file]), list_fname );						//Add the file name, then the path name of the SER file is completed.

				if( fp1 != NULL ) fclose(fp1);							//"fp1" is a pointer to a SER file.
				error = fopen_s ( &fp1, file_path[list_file], "rb" );	//Open the file. "rb" means "for read" and "in binary". The pointer is at the top of the file.
				if( error == 0 ) {			//When fopen_s succedds.
					read_header ( fp1 );	//Image size of a frame, grayscale, number of frames, etc. are obtained from the header of the SER file.
					SetDlgItemInt( hDlg, IDC_EDIT_WIDTH, ImageWidth, FALSE );
					SetDlgItemInt( hDlg, IDC_EDIT_HEIGHT, ImageHeight, FALSE );
					bit_shift = GetDlgItemInt( hDlg, IDC_EDIT_BIT_SHIFT, &check, TRUE );	//This is the only statement where "bit_shift" is obtained from the EditControl.
					LIST2_add();			//The header informations are shown in LIST2.

					//Determining the reduction ratio of the display window.
					if( Button_GetCheck( hRadio_disp100 ) == BST_CHECKED ) disp_size = 1;				//The size of the image window is 100%.
						else if( Button_GetCheck( hRadio_disp50  ) == BST_CHECKED ) disp_size = 2;		//The size of the image window is  50%.
							else if( Button_GetCheck( hRadio_disp33  ) == BST_CHECKED ) disp_size = 3;	//The size of the image window is  33%.
								else disp_size = 4;														//The size of the image window is  25%.

					prep_for_display();
					ser_read( fp1 );		//Read image data from the SER file.

					c_frame = 0;			//"c_frame" is the frame number in a SER file.
					SetDlgItemInt( hDlg, IDC_EDIT_FRAME, c_frame, FALSE );

					blue_val = get_item_value( list_file, 7 );				//For the dark pixels, get a parameter from LIST2.
					red_val  = get_item_value( list_file, 8 );				//For the bright pixels.
					mag_brt  = get_item_value( list_file, 9 );				//For the display brightness factor.
					frame_display( Button_GetCheck( hCheck_blue_red ) );	//Display the first frame (c_frame = 0) in the image window.
					SetWindowText( g_img.hwin, file_path[list_file] );		//Change the name of the window.

					if( list_file < LIST_ITEM_MAX ) {			//LIST_ITEM_MAX is defined in header.h.
						list_file ++;							//"list_file" is the number of SER files in LIST2.
						LIST2_set_checkmark( list_file - 1 );	//Note: The item number of the newly added SER file is (list_file - 1).
					}
					else {
						sprintf_s(szBuf, 256, "The number of SER files >= %3d\nThe following files will overwrite!", LIST_ITEM_MAX);
						MessageBox(NULL, szBuf, "IDC_BUTTON_ADD", MB_OK);
					}
				}
				else {	//Error in fopen_s.
					MessageBox(NULL, "Error in fopen_s ( &fp1, file_path[list_file], \"rb\" )", "IDC_BUTTON_ADD", MB_OK );
					return TRUE;
				}
				break;

			case IDC_BUTTON_REMOVE:		//Remove a SER file from LIST2.
				if( list_file > 0 ) {	//"list_file" is the number of SER files in LIST2.
					for( i = 0; i < list_file; i++ ) {
						uiState = ListView_GetItemState( hList2, i, LVIS_SELECTED | LVIS_FOCUSED ); 
						if ( uiState & LVIS_FOCUSED ) {				//If the item is focused.
							n_item = LIST2_get_checkmarked_item();	//Get the item number for which the left end column in LIST2 shows "1".
							if( i == n_item ) check = TRUE;
							else check = FALSE;

							ListView_DeleteItem( hList2, i );		//Delete the item.

							for( i; i < list_file - 1; i++ ) {		//Rearrange the path names.
								for( j = 0; j < MAX_PATH; j++ ) {
									file_path[i][j] = file_path[i+1][j];
								}
							}

							list_file --;			//Decrease the number of SER files to be scanned.

							if( check == TRUE || list_file == 0 ) {
								DestroyWindow( g_img.hwin );
								c_frame = 0;
								SetDlgItemInt( hDlg, IDC_EDIT_FRAME, c_frame, FALSE );
							}
							LIST2_deselect();		//Make SELECTED and FOCUSED states OFF for all SER files in LIST2.

							return TRUE;
						}
					}
				}
				break;
		
			case IDC_BUTTON_FRAME:		//Disply a frame in the image window.
				n_item = LIST2_get_checkmarked_item();								//Get the item number for which the left end column in LIST2 is "1".
				if( n_item < 0 ) break;
				c_frame = GetDlgItemInt( hDlg, IDC_EDIT_FRAME, &check, TRUE );		//Get a frame number in the EditControl.
				c_frame = c_frame_check( n_item );									//Make a correction to "c_frame" if necessary.
				SetDlgItemInt( hDlg, IDC_EDIT_FRAME, c_frame, FALSE );				//Show the frame number in the EditControl.			
				_fseeki64 ( fp1, (__int64)HEADER_SIZE + (__int64)c_frame * (__int64)ImageSize * 2, SEEK_SET );	//The pointer "fp1" is at the top of image data.
				ser_read( fp1 );
				blue_val = get_item_value( n_item, 7 );					//For the dark pixels, get a parameter from LIST2.
				red_val  = get_item_value( n_item, 8 );					//For the bright pixels.
				mag_brt  = get_item_value( n_item, 9 );					//For the display brightness factor.
				frame_display( Button_GetCheck( hCheck_blue_red ) );	//Display the frame in the image window.
				break;

			case IDC_BUTTON_FILE_TO_FILE:	//Scan SER files in LIST2 one by one to find impact flashes.
				GetLocalTime(&st_start);					//Record the start time of the scans.

				SetDlgItemText( hDlg, IDC_EDIT_FRAME, "" );
				SetDlgItemText( hDlg, IDC_EDIT_X,     "" );
				SetDlgItemText( hDlg, IDC_EDIT_Y,     "" );
				SetDlgItemText( hDlg, IDC_EDIT_VALUE, "" );
				UpdateWindow( hDlg );

				if(list_file == 0) {
					MessageBox(NULL, "Error: There is no file to scan.", "IDC_BUTTON_FILE_TO_FILE", MB_OK);
					break;
				}

				for( i_scan = 0; i_scan < list_file; i_scan++ ) {	//"i_scan" corresponds to a SER file in LIST2.
					DestroyWindow( g_img.hwin );
					LIST2_set_checkmark( i_scan );
					UpdateWindow( hDlg );

					path_name1 = file_path[i_scan];			//Get the path name of a SER file to be scanned.
					wsprintf( ch, TEXT("%s"), path_name1 );
					file_name = PathFindFileName( ch );		//Extract the file name from the path name, "ch".
					PathRemoveExtension( file_name );		//Remove the extension from the file name.

					wsprintf( detect_dir, "Results_%s", file_name );	//Prepare a folder name based on the file name.
					_mkdir( detect_dir );								//Make a directory (a folder).
					wsprintf( detect_result_path, "%s\\%s_summary.txt", detect_dir, file_name );	//Prepare a file name.

					if( fp1 != NULL ) fclose(fp1);
					fopen_s( &fp1, path_name1, "rb" );
					str_header = read_header( fp1 );	//Image size of a frame, grey scale, number of frames, etc. are obtained from the header of the SER file.

					if( PixelDepthPerPlane == 16 ||  PixelDepthPerPlane == 8 ) {	//Only 16-bit or 8-bit grey scale SER files are scanned.
						read_parameter( i_scan );
						threshold0 = threshold;
			
						fopen_s( &fp2, detect_result_path, "w" );	//Open a text file in the writing mode "w" to write the informations below. The file name has been prepared just above.
						result_txtout1( str_header );				//Output header record informations of a SER file and parameters for scanning the file.
						fclose ( fp2 );

						ImageSize    = ImageWidth * ImageHeight;
					
						if( value16 != NULL ) free( value16 );
						value16     = (unsigned short *)malloc( ImageSize * sizeof( unsigned short ) );	//Allocating memories for a frame (These memories are used also in the case of an 8-bit greyscale SER file)
				
						SendMessage( hDlg, WM_COMMAND, MAKEWPARAM( IDC_SCAN, 0 ), 0 );	//Proceed to "case IDC_SCAN" below.
					}

				}

				free( value16 );
				GetLocalTime(&st_end);		//Record the end time of the scans.

				//MessageBox informs the end of the scans.
				sprintf_s( szBuf, 512,   "Month_Day %02d_%02d  %02dh%02dm%02ds\n", st_start.wMonth, st_start.wDay, st_start.wHour, st_start.wMinute, st_start.wSecond );	//Print the start-time of the scan in szBuf.
				sprintf_s( szBuf, 512, "%sMonth_Day %02d_%02d  %02dh%02dm%02ds", szBuf, st_end.wMonth, st_end.wDay, st_end.wHour, st_end.wMinute, st_end.wSecond );			//Add the end-time of the scan in szBuf.
				MessageBox( NULL, szBuf, "The scans of all SER files completed!", MB_OK );

				break;

			case IDC_SCAN:		//A detection process for a SER file.
				prep_bmp_ih();		//Prepare a BITMAPINFOHEADER for images.
				ave			= ( double * )calloc( ImageSize, sizeof( double ) );	//Allocate memories and initialize them with 0.
				sigma		= ( double * )calloc( ImageSize, sizeof( double ) );
				star_on	= ( BOOL   * )calloc( ImageSize, sizeof( BOOL   ) );

				n_frames = 0;		//"n_frames" is the number of frames that contain detections.
				n_detection = 0;	//"n_detection" is the number of detections in a SER file.

				total_packet = (end - start + 1) / packet_size;		//Frames in a SER file are divided in packets each of which consists of "packet_size" frames.
				r_frames	 = (end - start + 1) % packet_size;		//Number of residual frames when the frames are divided in the packets.
			
				error = fopen_s( &fp2, detect_result_path, "a" );	//Open a text file in the writing mode "a" to add the results of the scan.
				if( error !=0 ){
					MessageBox(NULL, "Error in fopen_s(&fp2, detect_result_path, \"a\")", "case IDC_SCAN", MB_OK);
				}

				//Scan a SER file with "threshold0" first, then "threshold0 - d_threshold", and so on.
				threshold = threshold0 + d_threshold;				//Note: At the biginning of the "while" statement below, the threshold for detections is reduced by "d_threshold".
				while( n_frames < detect_limit && threshold >= THRESHOLD_LIMIT + d_threshold ) {	//THRESHOLD_LIMIT is defined in header.h.		
					threshold -= d_threshold;						//"d_threshold" is obtained from one of the EditControls in the DialogBox.
					SetDlgItemInt( hDlg, IDC_EDIT_THRESHOLD, threshold, FALSE );
					UpdateWindow( hDlg );
					c_frame = start;								//"start" is the frame# of a SER file where the scan start. It is obtained from LIST2.
					star_off();										//No star (An initial condition).
					
					result_txtout2();								//Output results for a threshold value.

					for( k = 0; k < total_packet; k++ ){	//"total_packet" is the number of packet in a ser file.
						image_ave_and_std();				//Calculating a temporal average and a temporal standard deviation of each pixel over a frame packet.

						//Mask areas.
						if( Button_GetCheck( hCheck_mask_bright ) == BST_CHECKED ) mask_bright();			//for bright areas (nearly saturated areas).
						if( Button_GetCheck( hCheck_mask_dark   ) == BST_CHECKED ) mask_dark();				//for dark areas (outside Lunar disk).
						if( Button_GetCheck( hCheck_mask_star )   == BST_CHECKED ) mask_star();	//for stars.

						//Mask areas that are manually defined.
						mask_manual( mask_manual_TL[0], mask_manual_BR[0] );
						mask_manual( mask_manual_TL[1], mask_manual_BR[1] );
						mask_manual( mask_manual_TL[2], mask_manual_BR[2] );
						mask_manual( mask_manual_TL[3], mask_manual_BR[3] );

						check = search( packet_size );		//Search for impact flashes for frames in a packet.
						if( check == TRUE ) break;			//In case the number of detections exceeds the pre-set value, "check" is TRUE.

						UpdateWindow( hDlg );
					}

					if( r_frames != 0 && check == FALSE ) {	//If there are residual frames when the frames are divided in the packets.
						check = search( r_frames );
					}

					if( check == TRUE ) {					//When the number of frames with detections exceeds the pre-set value.
						if( threshold < threshold0 ) break;	//Note: No revision of the threshold value means that the SER file was not scanned to its end.
						else {
							fprintf( fp2, "\n--------------------------------------------------------------------\n" );
							fprintf( fp2, "Number of frames that include detections = %d\n", n_frames );
							fprintf( fp2, "Number of detections = %d\n", n_detection );
							fprintf( fp2, "\n------Too many detections prevented a scan through the file.--------\n" );
							fprintf( fp2, "\n------The threshold is increased, and the file is scanned again.----\n" );
							n_frames = 0;					//"n_frames" is the number of frames that contain detections.
							n_detection = 0;				//"n_detection" is the number of detections in a SER file.
							threshold0 = threshold0 + d_threshold;	//Increase the initial threshold because the the threshold would have been too small.
							threshold  = threshold0 + d_threshold;	//Note: At the biginning of the "while" statement, the threshold for detections is reduced by "d_threshold".
						}
					}

				}

				//After the scan of a SER file;
				fprintf( fp2, "\n--------------------------------------------------------------------\n" );
				fprintf( fp2, "Number of frames that include detections = %d\n", n_frames );
				fprintf( fp2, "Number of detections = %d\n", n_detection );
				fprintf( fp2, "--------------------------------------------------------------------\n\n" );

				SetDlgItemInt( hDlg, IDC_EDIT_FRAME, c_frame, FALSE ); //"c_frame" is the frame# in a SER file.
				UpdateWindow( hDlg );
				n_frames = 0;			//"n_frames" is the number of frames in a SER file that contain detections.

				//The following 2 lines may not work properly.
				wsprintf( detect_dir_c_frame, "%s_s%d_%d", detect_dir, threshold, c_frame );
				rename( detect_dir, detect_dir_c_frame );	//int rename(const char *old, const char *new)

				free( ave ); free( sigma ); free( star_on );
				fclose( fp2 );

				return TRUE;

			case IDCANCEL:			//A procedure when X at the top-right of the window is clicked.
				PostQuitMessage( 0 );
				DestroyWindow ( hDlg );
				DestroyWindow ( g_img.hwin );
				fclose( fp1 );
				free ( value16 );
				free ( ave );
				free ( sigma );
				free ( star_on );
				return TRUE;

		}				//The end of switch(LOWORD(wp)).

		return TRUE;

	}					//The end of switch(msg).
	return FALSE;
}

//Dialogue procedure for IDD_DIALOG2
BOOL CALLBACK dlgproc2( HWND hDlg2, UINT msg, WPARAM wp, LPARAM lp )
{
	switch ( msg ) {

	case WM_INITDIALOG:
		SetDlgItemText( hDlg2, IDC_EDIT_DLG2, buf_for_dlg2 );	//Show an item in IDD_List2 (List control).
		break;

	case WM_COMMAND:
		switch ( LOWORD(wp) ) {
			case IDOK:
				GetDlgItemText( hDlg2, IDC_EDIT_DLG2, buf_for_dlg2, 256 );	//Get a new value typed in IDC_EDIT_DLG2 (Edit Control) for the item.
				EndDialog( hDlg2, IDOK );
				return TRUE;
			case IDCANCEL:
				EndDialog( hDlg2, IDCANCEL );
				return TRUE;
		}
		return FALSE;
	}
	return FALSE;
}
