#include  "header.h"

char list_fname[50];						//An SER file name.
char file_path[LIST_ITEM_MAX][MAX_PATH];	//Path names of SER files [item#][number of characters]. MAX_PATH=260.

HINSTANCE hInst;
HWND hDlg, hImage0;							//Handles of a DialogBox and an image window.
HWND hCheck_mask_bright, hCheck_mask_dark;	//Handles of CheckButtons for masking bright and dark areas.
HWND hCheck_mask_star;						//A handle of a CheckButton for masking around stars.
HWND hRadio_mask1, hRadio_mask2, hRadio_mask3, hRadio_mask4;	//Handles of RadioButtons for manual-mask-regions.
HWND hCheck_disp_mask;											//A handle for showing manual-mask-regions.

HWND   hList2;								//A handle of IDC_LIST2, a ListBox in the right of the DialogBox.
LVITEM list_item;							//A List View Item structure.
int	   list_file;							//The number of SER files in LIST2.

IMG0 g_img;									//See header.h for IMG0.
char szClassName0[] = "img_data0";			//A class name of an image window.

FILE *fp1;				//For SER files.
FILE *fp2;				//For output files.

int bit_shift;				//"bit_shift=1, 2, 3" correspond to dividing a pixel value in 16-bit by 2, 4, 8 in reading SER files.
unsigned short *value16;	//An image or a frame.
double *ave;				//A time-averaged image.
double *sigma;				//A temporal standard deviation image.
BOOL   *star_on;			//A BOOL image for masking pixels around stars.

int ImageWidth, ImageHeight, PixelDepthPerPlane, FrameCount;	//the width, height, grayscale, and total number of frames of a SER file
int ImageWidth2, ImageHeight2, ImageSize;	//the width and height of images displayed in the image window, and the number of pixels in an original frame
int disp_size;				//the size of the image window: 1 for 100%, 2 for 50%, 3 for 33%, and 4 for 25%

char detect_dir[100];			//a name of a folder that contains outputs of scans
char detect_result_path[200];	//a pathname of a log file
char detect_dir_c_frame[100];	//for the new name of a folder that contains outputs of scans

int c_frame;									//A frame# in a SER file.
int total_frame, start, end, detect_limit, packet_size, blue_val, red_val, mag_brt, threshold, d_threshold, hidari, migi, ue, shita;
int mask_area1, mask_area2, mask_area3;			//Sizes of mask areas around bright, dark, and star pixels.
int star_size, star_threshold;					//A size of background areas in searching stars, and a threshold in searching stars.
POINTS mask_manual_TL[4], mask_manual_BR[4];	//Top-left and bottom-right coordinates of manual-mask-areas.
int scatter_i, scatter_j;						//upper limits of the scatter of y- and x-coordinates of the detected points
int n_detection, n_frames;						//"n_detection" is the number of detections in a SER file, and "n_frames" is the number of frames that contain detections.

char buf_for_dlg2[256];	//used for a small DialogBox.
char szBuf[256];		//For general purpose.

//-------------------------------------------------------------------
int WINAPI WinMain( HINSTANCE hCurInst, HINSTANCE hPrevInst,
					LPSTR lpszCmdLine, int nCmdShow )
{
	MSG msg;
	BOOL bRet;

	hInst = hCurInst;
	g_img.hi0 = hCurInst;
	g_img.hwin = NULL;
	g_img.lpBmpData = NULL;

	if (!InitApp0(hCurInst))	//"InitApp0" is for an image window.
		return FALSE;
	hDlg = CreateDialog( hCurInst, "IDD_DIALOG1", HWND_DESKTOP,	//Create a main DialogBox.
					(DLGPROC)dlgproc);
	while ((bRet = GetMessage(&msg, NULL, 0, 0)) != 0) {		//So called "Message Loop".
		if (bRet == -1) {
			break;
		} else {
			if ( !hDlg || !IsDialogMessage(hDlg, &msg) ) {
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}

	free( g_img.lpBmpData );
	return TRUE;
}

//For the image window:
ATOM InitApp0( HINSTANCE hInst )
{
	WNDCLASSEX  wc0;
	memset( &wc0, 0, sizeof(WNDCLASSEX));
	wc0.cbSize        = sizeof(WNDCLASSEX);
	wc0.lpfnWndProc   = WndProc0;				//The name of the window procedure (CALLBACK function) is "WndProc0".
	wc0.hInstance     = hInst;
	wc0.hbrBackground = (HBRUSH)GetStockObject( WHITE_BRUSH );
	wc0.lpszClassName = (LPCSTR)szClassName0;
	return (RegisterClassEx( &wc0 ));	
}

//For the image window:
BOOL InitInstance0(HINSTANCE hInst, int nCmdShow)
{
	int y_cap = GetSystemMetrics(SM_CYCAPTION);		//The height of the caption area that shows the window name.
	int y_frm = GetSystemMetrics(SM_CYFIXEDFRAME);	//The width of the upper and lower frame sides.
	int x_frm = GetSystemMetrics(SM_CXFIXEDFRAME);	//The width of the left and right frame sides.

	RECT rect;	//The coordinates and size of the main DialogBox.

	if( GetWindowRect( hDlg, &rect ) == FALSE ) {	//Get the coordinates and size of the main DialogBox by "GetWindowRect".
		MessageBox( NULL, "GetWindowRect( hDlg, &rect ) == FALSE", "InitInstance0", MB_OK );
		return TRUE;
	}

	//Create an image window.
	g_img.hwin = CreateWindow( (LPCSTR)szClassName0,
								"SER movie frame",					//The caption for the image window.
								WS_OVERLAPPED | WS_VISIBLE,			//Properties of the image window.
								rect.left - ImageWidth2, rect.top,	//The image window is placed just left of the main DialogBox.
								ImageWidth2  + y_frm * 2 + 10, 
								ImageHeight2 + y_cap + x_frm * 2 + 10,
								NULL,
								NULL, hInst, NULL );

	if( !g_img.hwin ) {
		MessageBox(NULL,"Error: g_img.hwin is empty.","InitInstance0",MB_OK);
		return FALSE;
	}

	ShowWindow( g_img.hwin, nCmdShow );
	UpdateWindow( g_img.hwin );

	return TRUE;
}

//A sample of the MessageBox function.
//sprintf_s( szBuf, 256, "%3d", xxx);
//MessageBox(NULL, szBuf, "MessageBox", MB_OK);
