#include  "header.h"

//Window procedure
LRESULT CALLBACK WndProc0( HWND hImage0, UINT msg, WPARAM wp, LPARAM  lp  )
{
	POINTS mp0, mp1, mp2;		//For a mouse pointer:
	static BOOL bDraw;			//"A flag that show selecting a mask region.
	static POINTS start, end, old_end;
	int i, j, ij;
	BOOL check;					//Used in "GetDlgItemInt" functions.

	switch (msg) {
	case WM_PAINT:				//Paint a BITMAP image.
		HDC hdc0, hdc_mem0;		//Handles for a Device Context and a Memory Device Context.
		PAINTSTRUCT	ps0;
		HBITMAP hBmp0;			//A handle for a BITMAP.
		                                            
		hdc0 = BeginPaint( hImage0, &ps0 );			//Get a Device Context.
		hdc_mem0 = CreateCompatibleDC( hdc0 );		//Get a Memory Device Context.
		hBmp0 = CreateDIBitmap( hdc0,	&( g_img.bmp_ih ), CBM_INIT, g_img.lpBmpData,	//Create a BITMAP image.
								(BITMAPINFO *)(&( g_img.bmp_ih )), DIB_RGB_COLORS );
		SelectObject(hdc_mem0, hBmp0);				//Select the BITMAP for a Memory Device Context.

		SetStretchBltMode( hdc0 , COLORONCOLOR );	//Set one of the stretch modes for the Device Context, "hdc0".
		StretchBlt(hdc0, 0, 0, ImageWidth2, ImageHeight2, hdc_mem0, 0, 0, ImageWidth, ImageHeight, SRCCOPY);

		DeleteDC( hdc0 );
		DeleteDC( hdc_mem0 );
		DeleteObject( hBmp0 );
		EndPaint( hImage0, &ps0 );

		//Show manual-mask-regions if checked in the DialogBox.
		if( Button_GetCheck( hCheck_disp_mask ) == BST_CHECKED ) {
			start.x = GetDlgItemInt( hDlg, IDC_EDIT_TL_X1, &check, TRUE ) / disp_size;
			start.y = GetDlgItemInt( hDlg, IDC_EDIT_TL_Y1, &check, TRUE ) / disp_size;
			end.x = GetDlgItemInt( hDlg, IDC_EDIT_BR_X1, &check, TRUE ) / disp_size;
			end.y = GetDlgItemInt( hDlg, IDC_EDIT_BR_Y1, &check, TRUE ) / disp_size;
			DrawRect( hImage0, start, end, R2_NOT );

			start.x = GetDlgItemInt( hDlg, IDC_EDIT_TL_X2, &check, TRUE ) / disp_size;
			start.y = GetDlgItemInt( hDlg, IDC_EDIT_TL_Y2, &check, TRUE ) / disp_size;
			end.x = GetDlgItemInt( hDlg, IDC_EDIT_BR_X2, &check, TRUE ) / disp_size;
			end.y = GetDlgItemInt( hDlg, IDC_EDIT_BR_Y2, &check, TRUE ) / disp_size;
			DrawRect( hImage0, start, end, R2_NOT );

			start.x = GetDlgItemInt( hDlg, IDC_EDIT_TL_X3, &check, TRUE ) / disp_size;
			start.y = GetDlgItemInt( hDlg, IDC_EDIT_TL_Y3, &check, TRUE ) / disp_size;
			end.x = GetDlgItemInt( hDlg, IDC_EDIT_BR_X3, &check, TRUE ) / disp_size;
			end.y = GetDlgItemInt( hDlg, IDC_EDIT_BR_Y3, &check, TRUE ) / disp_size;
			DrawRect( hImage0, start, end, R2_NOT );

			start.x = GetDlgItemInt( hDlg, IDC_EDIT_TL_X4, &check, TRUE ) / disp_size;
			start.y = GetDlgItemInt( hDlg, IDC_EDIT_TL_Y4, &check, TRUE ) / disp_size;
			end.x = GetDlgItemInt( hDlg, IDC_EDIT_BR_X4, &check, TRUE ) / disp_size;
			end.y = GetDlgItemInt( hDlg, IDC_EDIT_BR_Y4, &check, TRUE ) / disp_size;
			DrawRect( hImage0, start, end, R2_NOT );
		}
		return 0;

	case WM_MOUSEMOVE:
		mp0 = MAKEPOINTS(lp);									//Get the mouse coordinates, mp0, in the window.
		mp1.x = mp0.x * disp_size; mp1.y = mp0.y * disp_size;	//"mp1" is the coordinates in the original image.

		//When "mp1" is out of the original image, it is set to the edge of the image.
		if( mp1.x < 0 ) mp1.x = 0;
		if( mp1.y < 0 ) mp1.y = 0;
		if( mp1.x >= ImageWidth  ) mp1.x = ImageWidth  - 1;
		if( mp1.y >= ImageHeight ) mp1.y = ImageHeight - 1;

		SetDlgItemInt( hDlg, IDC_EDIT_X, mp1.x, FALSE );	//Show the coordinates in the original image, mp1, in the EDIT BOX.
		SetDlgItemInt( hDlg, IDC_EDIT_Y, mp1.y, FALSE );
		ij = ImageWidth * mp1.y + mp1.x;					//"ij" is the element index in the image file.
		sprintf_s( szBuf, 256, "%6d", value16[ij] );		//Translate the pixel value at "ij" to characters.
		SetDlgItemText( hDlg, IDC_EDIT_VALUE, szBuf );		//Show the characters in the EditBox.

		if( bDraw ) {		//During the manual-mask-area setting, bDraw==TRUE.
			end = MAKEPOINTS(lp);		//Read the coordinates of a mouse cursor.
			DrawRect(hImage0, start, old_end, R2_NOT);	//An old rectangular is over-draw and removed.
			DrawRect(hImage0, start, end, R2_NOT);		//Draw a new rectangular.
			old_end = end;
		}

		return 0;

	case WM_RBUTTONDOWN:	//Start the selection of a mask region.
		bDraw = TRUE;		//"bDraw" is a flag that show selecting a mask region.

		mp2 = MAKEPOINTS(lp);
		//When "mp2" is out of the window, it is set to the edge of the window.
		if( mp2.x < 0 ) mp2.x = 0;
		if( mp2.y < 0 ) mp2.y = 0;
		if( mp2.x >= ImageWidth2  ) mp2.x = ImageWidth2  - 1;
		if( mp2.y >= ImageHeight2 ) mp2.y = ImageHeight2 - 1;
		old_end = mp2;

		i = old_end.y * disp_size;	//"old_end.y" is the coordinate in the window, and "i" is the coordinate in the original image.
		j = old_end.x * disp_size;

		if(Button_GetCheck(hRadio_mask1) == BST_CHECKED) {
			start.x = 0; start.y = 0;
			SetDlgItemInt( hDlg, IDC_EDIT_TL_X1, 0, FALSE );
			SetDlgItemInt( hDlg, IDC_EDIT_TL_Y1, 0, FALSE );
			SetDlgItemText( hDlg, IDC_EDIT_BR_X1, "" );			//Make the EDIT BOX empty.
			SetDlgItemText( hDlg, IDC_EDIT_BR_Y1, "" );			//Make the EDIT BOX empty.
		}

		if(Button_GetCheck(hRadio_mask2) == BST_CHECKED) {
			start.x = ImageWidth2-1; start.y = 0;
			SetDlgItemText( hDlg, IDC_EDIT_TL_X2, "" );			//Make the EDIT BOX empty.
			SetDlgItemInt( hDlg, IDC_EDIT_TL_Y2, 0, FALSE );
			SetDlgItemInt( hDlg, IDC_EDIT_BR_X2, ImageWidth-1, FALSE );
			SetDlgItemText( hDlg, IDC_EDIT_BR_Y2, "" );			//Make the EDIT BOX empty.
		}

		if(Button_GetCheck(hRadio_mask3) == BST_CHECKED) {
			start.x = 0; start.y = ImageHeight2-1;
			SetDlgItemInt( hDlg, IDC_EDIT_TL_X3, 0, FALSE );
			SetDlgItemText( hDlg, IDC_EDIT_TL_Y3, "" );			//Make the EDIT BOX empty.
			SetDlgItemText( hDlg, IDC_EDIT_BR_X3, "" );			//Make the EDIT BOX empty.
			SetDlgItemInt( hDlg, IDC_EDIT_BR_Y3, ImageHeight-1, FALSE );
		}

		if(Button_GetCheck(hRadio_mask4) == BST_CHECKED) {
			start.x = ImageWidth2-1; start.y = ImageHeight2-1;
			SetDlgItemText( hDlg, IDC_EDIT_TL_X4, "" );			//Make the EDIT BOX empty.
			SetDlgItemText( hDlg, IDC_EDIT_TL_Y4, "" );			//Make the EDIT BOX empty.
			SetDlgItemInt( hDlg, IDC_EDIT_BR_X4, ImageWidth-1, FALSE );
			SetDlgItemInt( hDlg, IDC_EDIT_BR_Y4, ImageHeight-1, FALSE );
		}

		DrawRect(hImage0, start, old_end, R2_NOT);		//Draw the first rectangular.

		return 0;

	case WM_RBUTTONUP:		//Finish the selection of the mask region.
		if( bDraw ) {		//"bDraw" is a flag that show selecting a mask region.
			SetCursor(LoadCursor(NULL, IDC_ARROW));
			bDraw = FALSE;

			end = MAKEPOINTS(lp);
			//When "end" is out of the window, it is set to the edge of the window.
			if( end.x < 0 ) end.x = 0;
			if( end.y < 0 ) end.y = 0;
			if( end.x >= ImageWidth2  ) end.x = ImageWidth2  - 1;
			if( end.y >= ImageHeight2 ) end.y = ImageHeight2 - 1;

			i = end.y * disp_size;	//"end.y" is the coordinate in the window, and "i" is the coordinate in the original image.
			j = end.x * disp_size;

			if(Button_GetCheck(hRadio_mask1) == BST_CHECKED) {
				SetDlgItemInt( hDlg, IDC_EDIT_BR_X1, j, FALSE );
				SetDlgItemInt( hDlg, IDC_EDIT_BR_Y1, i, FALSE );
			}

			if(Button_GetCheck(hRadio_mask2) == BST_CHECKED) {
				SetDlgItemInt( hDlg, IDC_EDIT_TL_X2, j, FALSE );
				SetDlgItemInt( hDlg, IDC_EDIT_BR_Y2, i, FALSE );
			}

			if(Button_GetCheck(hRadio_mask3) == BST_CHECKED) {
				SetDlgItemInt( hDlg, IDC_EDIT_BR_X3, j, FALSE );
				SetDlgItemInt( hDlg, IDC_EDIT_TL_Y3, i, FALSE );
			}

			if(Button_GetCheck(hRadio_mask4) == BST_CHECKED) {
				SetDlgItemInt( hDlg, IDC_EDIT_TL_X4, j, FALSE );
				SetDlgItemInt( hDlg, IDC_EDIT_TL_Y4, i, FALSE );
			}
		}

		return 0;

	default:
		return DefWindowProc( hImage0, msg, wp, lp );
	}

	return 0;
}
